<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: 0f86139 (2019-04-03 09:30:52)
//

defined('_QUICK_LP') or die("Access denied");

class sitemapQLPAddon{
	private static $backstep=7;
	private static $changefreq_arr=array('always','hourly','daily','weekly','monthly','yearly','never');
	private static $changefreq=4;
	private static $priority=0.5;
	public static function proceed(){
		$date = self::getDate();
		$xml = '<?xml version="1.0" encoding="UTF-8"?>'.CR_LF;
		$xml.= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">'.CR_LF;
		$xml.= '<url>'.CR_LF;
		$xml.= '<loc>'.QLPRequest::getCurrentProtocol().'://'.QLPRequest::getHost().'/</loc>'.CR_LF;
		$xml.= '<lastmod>'.date('c', $date).'</lastmod>'.CR_LF;
		$xml.= '<changefreq>'.self::$changefreq_arr[self::$changefreq].'</changefreq>'.CR_LF;
		$xml.= '<priority>'.self::$priority.'</priority>'.CR_LF;
		$xml.= '</url>'.CR_LF;
		$xml.= '</urlset>';

		header("Content-Type: text/xml");
		header("Expires: Thu, 19 Feb 1998 13:24:18 GMT");
		header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
		header("Cache-Control: no-cache, must-revalidate");
		header("Cache-Control: post-check=0,pre-check=0");
		header("Cache-Control: max-age=0");
		header("Pragma: no-cache");
		
		echo $xml;
		
		QLPUtil::halt();
	}
	public static function getDate(){
		$date=time() - self::$backstep * 24 * 60 * 60;
		$day=date("d", $date);
		$month=date("m", $date);
		$year=date("Y", $date);
		return mktime(12, 21, 12, $month, $day, $year);
	}
}