<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: a974ae2 (2016-05-10 08:47:48)
//

defined('_QUICK_LP') or die("Access denied");

class QLPWidget extends QLPSimpleObject {
	private static $_loaded  = array();
	private static $_enabled = array();
	private static $_render_count = 0;

	private function __construct($pluginName) {
		$this->initSimpleObject($pluginName);
	}
	public function prepare(){}
	public static function initialize() {
		$enabled = parse_ini_file(QLP_WIDGETS."widgets.ini",false);
		foreach ($enabled as $key=>$value) {
			self::$_enabled[$key] = intval($value);
		}
		$_widgets = QLPFilesystem::getFolders(QLP_WIDGETS);
		if(count($_widgets)){
			foreach($_widgets as $_widget=>$_data){
				if(is_file(QLP_WIDGETS.$_widget.DS."index.php")){
					if (self::isEnabled($_widget)){
						require_once QLP_WIDGETS.$_widget.DS."index.php";
						$_widgetClass=$_widget."QLPWidget";
						if (class_exists($_widgetClass,0)) {
							self::$_loaded[$_widget] = new $_widgetClass($_widget);
							self::$_loaded[$_widget]->prepare();
						}
					}
				}
			}	
		}
	}
	public static function isEnabled($key){
		if(array_key_exists($key, self::$_enabled)) return self::$_enabled[$key]; 
		else return 0;
	}
	public static function proceed($name, $params){
		if(array_key_exists($name, self::$_loaded)){
			self::$_render_count++;
			$widget=self::$_loaded[$name];
			return $widget->render(self::$_render_count, $params);
		} else return "";
	}
}
?>