<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: c6b078d (2020-07-19 16:42:18)
//

defined('_QUICK_LP') or die("Access denied");
?>
<div class="help-panel">
<h3>User's manual</h3>
<p>To control the Quick-LP system you do not need to be a certified site administrator. Managing of it is simply and in that you will sure after reading this little manual.
From the main control panel, which is located at <span style="white-space: nowrap;"> http://YOUR_SITE_NAME/manager.php </span> you can select the section you are interested.</p>
<p><b>Login (default):</b> admin</p>
<p><b>Password (default):</b> admin</p>
<p><b class="red">Be sure to change the username and password in the "Settings" section after the first installation.</b></p>
<p>By selecting the appropriate button you will get in any section. The controls are intuitive and contain appropriate icons and tooltips. For example:<br /> 
"<span class="glyphicon glyphicon-plus"></span>" is "Add",<br />
"<span class="glyphicon glyphicon-pencil"></span>" is "Modify",<br />
"<span class="glyphicon glyphicon-remove"></span>" is "Delete" etc.</p>
<p>For return to the control panel just click "<span class="glyphicon glyphicon-paperclip"></span>" in top left corner of the page.</p>
<h4></a><span class="glyphicon glyphicon-globe"></span>Site</h4>
<p>Going directly to the main page of your site. It will open in a new window or a new tab, depending on the settings of your browser.</p>
<h4><a id="settings"></a><span class="glyphicon glyphicon-wrench"></span>Settings</h4>
<p>This section contains the basic settings of your site. If you do not fully understand the function of some option then just do not change it. The default values are selected, based on the optimal system performance.</p> 
<ul>
<li><b>Site template</b> - your site template</li>
<li><b>Site memory limit</b> - system setting, which usually does not require changes</li>
<li><b>Site time limit</b> - system setting, which usually does not require changes</li>
<li><b>Admin login</b> - The name by which you will enter the administration panel</li>	
<li><b>Password</b> - your password</li>
<li><b>Password confirmation</b> - your password confirmation</li>
<li><b>Admin template</b> - control panel template</li>
<li><b>Admin memory limit</b> - system setting, which usually does not require changes</li>
<li><b>Admin time limit</b> - system setting, which usually does not require changes</li>
<li><b>Site meta title</b> - site meta title</li>
<li><b>Site meta keywords</b> - Keywords for which the site is indexed by search engines</li>
<li><b>Site meta description</b> - Brief description of your site</li>
<li><b>Mailer from Email</b> - The email address that will receive letters from your website submited by forms "Contact us" and "Request a call"</li>
<li><b>Mailer from name</b> - The name that will be substituted in the sender field in mail coming from your site</li>
<li><b>Mailer successfull message</b> - The message that the user sees in the case of a successful send mail</li>
<li><b>Mailer failed message</b> - The message that the user sees in the case of failure to send mail</li>
<li><b>SMTP user</b> - Login to your email account (check it from your administrator or ISP)</li>
<li><b>SMTP password</b> - Password to your email account (check it from your administrator or ISP)</li>
<li><b>SMTP host</b> - Outgoing mail server for your email account (check it from your administrator or ISP). If your mail server uses a secure connection, that such servers yandex.ru, you need to specify the prefix of a secure connection. Fully server name for address smtp.yandex.com will look like: ssl://smtp.yandex.com</li>
<li><b>SMTP port</b> - Port of your mail server (check it from your administrator or ISP)</li>
<li><b>Debug mode</b> - Debug mode is intended primarily for developers and during normal operating of the site must be turned off</li>
<li><b>Experimental functions</b> - Enables or disables functions that are in development and testing. Use with caution, enable only on your own risk</li>
<li><b>Language</b> - System language</li>
<li><b>Deny mobile scale</b> - Some templates are not always correctly displayed on mobile devices (tablets, smartphones). Enabling this option can correct the situation.</li>
<li><b>Unlock key</b> - Quick-LP CMS is freely available for non-commercial use. If no key entered then Quick-LP CMS copyright is displayed on your site. The system functionality is not limited. If you for some reason do not want copyright to be displayed, you can purchase an unlock key. For commercial use of Quick-LP CMS - please contact the developers or their representatives via the website <a href="http://quick-lp.ru/" target="_blank">http://quick-lp.ru/</a>.</li>
</ul>
<h4><a id="pages"></a><span class="glyphicon glyphicon-file"></span>Pages</h4>
<p>In this section you can edit the text blocks that are displayed on your site. The blocks are called in Latin letters without spaces and have the extension ".txt". If you move your mouse over the file name, the tooltip you see will show the beginning of the text that it contains.</p>
<p>If you do not editing the website template to suit your needs, and want to use one of the standard templates or received (bought) already a template for your site, the names of these files do not need to be changed.</p>
<p>After the name changed, they will no longer appear on the main page of your site. It is provided a convenient and modern visual editor to edit the text. To get detailed help on using it, just click the icon "question mark" on the editor toolbar and click on the link.</p>
<h4><a id="filemanager"></a><span class="glyphicon glyphicon-folder-open"></span>Filemanager</h4>
<p>After the first installation "Filemanager" is not connected yet. To connect it confirm your agreement to its terms of use by clicking on the word "here". Installation will take place in the automatic mode and the "Filemanager" will open automatically. According to its characteristics it is like the usual explorer in Windows, so using it is easy and familiar.
Now a little about the structure of the folders on your website.</p>
<ul>
<li><b>gallery</b> - this folder contains the data used by the widgets "Image Gallery" and "Slider". If you installed Quick-LP yourself, then the image gallery will match subfolder "gallery1", and sliders - subfolder "slider".
Widgets on your site will show (scroll) image data from this subfolders.
The number of displayed (scrolled) images depends on settings in the site template. If you installed Quick-LP yourself, then the template default value is 4. This means that the system will take 4 random images for each of the widgets from the appropriate subfolder.
As you can see to change a set of images is easy.</li>
<li><b>menu</b> - service folder that contains the settings for main menu of your site. Below will be discussed how to change these settings. Manually changing the files in this folder can break already configured menu, but you can always recreate it in the "Menu" section</li>
<li><b>media</b> - in this folder you can store various images and files that you may need to provide more complete information to your users (such as a price list, a link to which you have pasted in the text or in the menu item).</li>
<li><b>pages</b> - service folder that contains the text blocks which are placed on your site. They also do not require editing, adding or deleting through the "Filemanager". To do this go to "Pages" section as discussed above.</li>
</ul>
<h4><a id="widgets"></a><span class="glyphicon glyphicon-cog"></span>Widgets</h4>
<p>This section contains the panel to switch widgets on and off. Widgets are the blocks of your site that have more functionality than simple text blocks. For example:</p>
<ul>
<li>Percent pie charts.</li>
<li>The feedback form.</li>
<li>Image gallery.</li>
<li>Standard menu.</li>
<li>Preloader.</li>
<li>Image slider.</li>
<li>Yandex maps.</li>
</ul>
<h4><a id="plugins"></a><span class="glyphicon glyphicon-cog"></span>Plugins</h4>
<p>This section contains the panel to switch plugins on and off. A plugin is a system component that is not exactly displayed in the site template, but it makes certain actions. For example, outputs captcha code for the protection from bots in the feedback form.</p>
<h4><a id="menus"></a><span class="glyphicon glyphicon-cog"></span>Menus</h4>
<p>In this section you can add, edit, delete items of the main menu of your site, and change their order by simply dragging them up and down over the icon "<span class="glyphicon glyphicon-arrow-down"></span><span class="glyphicon glyphicon-arrow-up"></span>". </p>
<p>The item line contains 3 fields:</p>
<ul>
<li>Title</li>
<li>Anchor ID or link</li>
<li>Target if link</li>
</ul>
<p>Since all the blocks of your site are on the same page, for quick access to them you may want to scroll to them. In the template, there are anchors for them. Specifing the number of anchor in the field "ID anchor or link" you tell the system that when you click on this menu item you need to be scrolled to the block which stands near the active anchor.</p>
<p>Sometimes you want the menu item to be linked to an external site, or, for example, to download the file. It is enough to insert a link to this field by simply copying it from your browser's address bar.</p>
<p>The most difficult thing for the user is to use JavaScript-functions in the field "ID anchor or link".<br />
For example: javascript: qlp_backcall ('backcall') <br />This part of the functionality is intended for programmers. It allows you to greatly expand the possible behavior of the menu items, and requires special skills. So if you need to use (or modify existing) references of this kind, then you'd better turn to professionals. They will help you much more quickly and without damage to your site.</p>
<?php if(isset(QLPConfig::$experimentalFunctions) && QLPConfig::$experimentalFunctions) { ?>
	<h4><span class="glyphicon glyphicon-book"></span>Templates</h4>
	<p>Experimental function. It is in development. Use with caution, enable only on your own risk.</p>
<?php } ?>
<h4><span class="glyphicon glyphicon-home"></span>About</h4>
<p>This section contains the "Terms of use of Quick-LP CMS", and a list of all external components, extensions, etc., indicating (where known) types of licenses, authors, links to the developer's websites.</p>
<h4><span class="glyphicon glyphicon-flag"></span>Help</h4>
<p>Section you are reading now</p>
<h4><span class="glyphicon glyphicon-lock"></span>Logout</h4>
<p>Log out of the administration panel.</p>

<h4>Quick-LP CMS Developers team</h4>
</div>