<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: 6049a41 (2023-12-25 02:55:43)
//

defined('_QUICK_LP') or die("Access denied");

class blacklistQLPModule extends QLPSimpleObject{
	private static $_instance = null;
			
	private static function createInstance() {
		if (self::$_instance == null) {
			self::$_instance = new self();
		}
	}
	public static function getInstance() {
		self::createInstance();
		return self::$_instance;
	}
	private function __construct() {
		$this->initSimpleObject();
	}
	public function proceed($task=""){
		switch ($task){
			case "import":
				echo '<div class="panel-wrapper module-blacklist">';
				echo '<h1 class="panel-title form-title">'.QLPText::_("Blacklist import").'</h1>';
				echo '<div class="row"><div class="col-sm-12">';
				/*
				if (is_file(QLP_ADDONS."sendmail".DS."index.php")) {
					require_once QLP_ADDONS."sendmail".DS."index.php";
				} else {
					QLPUtil::setSystemMessage('Addon "sendmail" is absent');
				}
				*/
				$ip_list = array();
				$error = false;
				if(is_uploaded_file($_FILES['file4import']['tmp_name']) && ($fh = fopen($_FILES['file4import']['tmp_name'], "r"))) {
					while (!feof($fh)) {
						$line=trim(fgets($fh), "\"\n\r\t\v\x00");
						if($line && QLPUtil::isIP($line)) $ip_list[]=$line;
					}
					fclose($fh);
				} else {
					QLPUtil::setSystemMessage(QLPText::_('Can\'t upload file'));
					$error = true;
				}
				if(!$error && count($ip_list)){
					$blacklist = array();
					$blacklist_file = QLP_CONFIG."blacklist.txt";
					if (is_file($blacklist_file)) {
						if($fh = fopen($blacklist_file, "r")){
							while (!feof($fh)) {
								$line=trim(fgets($fh));
								if($line) $blacklist[]=$line;
							}
							fclose($fh);
						} else {
							QLPUtil::setSystemMessage(QLPText::_('Can\'t open file').' "'.$blacklist_file.'" '.QLPText::_('for readind'));
							$error = true;
						}
					}
					// QLPUtil::pre($blacklist);
					if(!$error){
						$new_ip_list = array();
						$found_count = 0;
						foreach ($ip_list as $ip){
							$found = false;
							foreach ($blacklist as $range){
								if(QLPUtil::ip_in_range($ip, $range)){
									// QLPUtil::pre('found '.$ip.' in range '.$range);
									$found = true;
									$found_count++;
									break;
								}
							}
							if(!$found) {
								if(array_key_exists($ip, $new_ip_list)) $new_ip_list[$ip]++;
								else $new_ip_list[$ip] = 1;
							}
						}
						// echo $found_count;
						// QLPUtil::pre(array_keys($new_ip_list));
						// QLPUtil::pre($new_ip_list);
						$ip_list_for_write = $new_ip_list;
						foreach($ip_list_for_write as $k=>$v){
							file_put_contents($blacklist_file, $k.PHP_EOL, FILE_APPEND);
						}
						/*
						if($fh = fopen($blacklist_file, "a")){
							foreach($ip_list_for_write as $k=>$v){
								if(fputs($fh, $k.PHP_EOL) === FALSE) {
									echo '<p class="error import-message">'.QLPText::_('Error while writing').': '.$k.'</p>';
								}
							}
							fclose($fh);
						} else {
							QLPUtil::setSystemMessage(QLPText::_('Can\'t open file').' "'.$blacklist_file.'" '.QLPText::_('for writing'));
							$error = true;
						}
						*/
						echo '<p class="import-message">'.QLPText::_('Total import records').': '.count($ip_list).'</p>';
						echo '<p class="import-message">'.QLPText::_('Already exist records').': '.$found_count.'</p>';
						echo '<p class="import-message">'.QLPText::_('New unique records').': '.count($new_ip_list).'</p>';
					}
				} else {
					QLPUtil::setSystemMessage(QLPText::_('No valid IP\'s found in uploaded file'));
				}

				
				echo '</div></div>';
				echo '</div>';
			break;
			default:
				echo	'<div class="panel-wrapper module-blacklist">
							<h1 class="panel-title form-title">'.QLPText::_("Blacklist import").'</h1>
							<form method="post" action="/manager.php" enctype="multipart/form-data">
								<input type="hidden" value="blacklist" name="module">
								<input type="hidden" value="import" name="task">
								<div class="row row-form">
									<div class="col-md-4 col-sm-12">'.QLPText::_("CSV file for import").':</></div>
									<div class="col-md-8 col-sm-12"><input type="file" name="file4import" class="form-control" required="required"></div>
								</div>
								<div class="buttons"><input type="submit" class="commonButton" name="import" value="'.QLPText::_("Proceed").'" id="import"></div>
							</form>
						</div>';
			break;
		}
		return true;
	}
}