<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: c6b078d (2020-07-19 16:42:18)
//

defined('_QUICK_LP') or die("Access denied");

class pluginsQLPModule extends QLPSimpleObject{
	private static $_instance = null;
			
	private static function createInstance() {
		if (self::$_instance == null) {
			self::$_instance = new self();
		}
	}
	public static function getInstance() {
		self::createInstance();
		return self::$_instance;
	}
	private function __construct() {
		$this->initSimpleObject();
	}
	public function proceed($task=""){
		switch ($task){
			case "save":
				$config="";
/*				
				$enabled = parse_ini_file(QLP_PLUGINS."plugins.ini",false);
				foreach($enabled as $key=>$opt){
					$config.=$key."=".QLPRequest::getInt($key."_enabled",0).chr(13);
				}
*/
				$_plugins = QLPFilesystem::getFolders(QLP_PLUGINS);
				foreach($_plugins as $key=>$opt){
					$config.=$key."=".QLPRequest::getInt($key."_enabled",0).chr(13);
				}
				file_put_contents(QLP_PLUGINS."plugins.ini", $config);
				QLPUtil::redirect("/manager.php?module=plugins",QLPText::_("Settings saved"));
			break;	
			default:
				echo '<div class="panel-wrapper module-plugins"><div class="row"><div class="col-md-12">';
				echo '<h1 class="panel-title form-title">'.QLPText::_("Plugins").'</h1>';
				echo '<div class="table-wrapper form-table-wrapper">';
				echo '<form method="post" action="/manager.php">';
				echo '<input type="hidden" value="plugins" name="module">';
				echo '<input type="hidden" value="save" name="task">';
				$_enabled = parse_ini_file(QLP_PLUGINS."plugins.ini",false);
				$_plugins = QLPFilesystem::getFolders(QLP_PLUGINS);
				$label_class = 'col-sm-11 col-xs-10 lbl';
				$data_class = 'col-sm-1 col-xs-2 data data-checkbox';
				if(count($_plugins)){
					foreach($_plugins as $_plugin=>$_data){
						if(array_key_exists($_plugin, $_enabled) && $_enabled[$_plugin]) $opt=1; else $opt=0;
						echo '<div class="row illuminated">
								<div class="'.$label_class.'">'.QLPText::_($_plugin." plugin").'</div>
								<div class="'.$data_class.'"><input id="plugin_'.$_plugin.'" name="'.$_plugin.'_enabled" value="1" '.($opt ? ' checked="checked"' : '').' type="checkbox" /></div>
							</div>';
					}
				}
				echo '<div class="buttons"><input class=\"button\" type="submit" value="'.QLPText::_("Save").'" /><a class="button" href="'.(QLPRequest::getSafe("return")=="front" ? "/": "/manager.php").'">'.QLPText::_("Close").'</a></div>';
				echo '</form>';
				echo '</div>';
				echo '</div></div></div>';
			break;
		}
		return true;
	}
}