<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: 368528c (2021-06-01 18:00:41)
//

defined('_QUICK_LP') or die("Access denied");

class settingsQLPModule extends QLPSimpleObject{
	private static $_instance = null;
			
	private static function createInstance() {
		if (self::$_instance == null) {
			self::$_instance = new self();
		}
	}
	public static function getInstance() {
		self::createInstance();
		return self::$_instance;
	}
	private function __construct() {
		$this->initSimpleObject();
	}
	public function proceed($task=""){
		switch ($task){
			case "save":
				$message="";
				$password=QLPConfig::$secret;
				$new_password=false;
				$login=QLPRequest::getSafe("adminLogin");
				$secret1=QLPRequest::getSafe("secret1","");
				$secret2=QLPRequest::getSafe("secret2","");
				if($secret1){
					if($secret1==$secret2){
						$new_password=true;
						$password=md5(md5($login.$secret1));
					} else $message=QLPText::_("Passwords are different");
				}
				$config ='<?php'.CR_LF;
				$config.='defined("_QUICK_LP") or die("Access denied");'.CR_LF;
				$config.='class QLPConfig {'.CR_LF;
				$config.='	public static $siteTemplate			= "'.QLPRequest::getSafe("siteTemplate").'";'.CR_LF;
				$config.='	public static $siteMemoryLimit		= "'.QLPRequest::getInt("siteMemoryLimit").'";'.CR_LF;
				$config.='	public static $siteTimeLimit		= "'.QLPRequest::getInt("siteTimeLimit").'";'.CR_LF;
				$config.='	public static $floodDelay			= "'.QLPRequest::getInt("floodDelay").'";'.CR_LF;
				$config.='	public static $siteCSS2footer		= "'.QLPRequest::getInt("siteCSS2footer").'";'.CR_LF;
				$config.='	public static $siteIncludeCSS2body	= "'.QLPRequest::getInt("siteIncludeCSS2body").'";'.CR_LF;
				$config.='	public static $siteIncludeJS2body	= "'.QLPRequest::getInt("siteIncludeJS2body").'";'.CR_LF;
				$config.='	public static $adminLogin 			= "'.$login.'";'.CR_LF;
				$config.='	public static $secret 				= "'.$password.'";'.CR_LF;
				$config.='	public static $adminTemplate		= "'.QLPRequest::getSafe("adminTemplate").'";'.CR_LF;
				$config.='	public static $adminMemoryLimit		= "'.QLPRequest::getInt("adminMemoryLimit").'";'.CR_LF;
				$config.='	public static $adminTimeLimit		= "'.QLPRequest::getInt("adminTimeLimit").'";'.CR_LF;
				$config.='	public static $siteCache 			= "'.QLPRequest::getInt("siteCache",0).'";'.CR_LF;
				$config.='	public static $siteCachetime		= "'.QLPRequest::getInt("siteCachetime",15).'";'.CR_LF;
				$config.='	public static $siteMetaDesc 		= "'.QLPRequest::getSafe("siteMetaDesc").'";'.CR_LF;
				$config.='	public static $siteMetaKeys 		= "'.QLPRequest::getSafe("siteMetaKeys").'";'.CR_LF;
				$config.='	public static $siteMetaTitle		= "'.QLPRequest::getSafe("siteMetaTitle").'";'.CR_LF;
				$config.='	public static $mailerFrom 			= "'.QLPRequest::getSafe("mailerFrom").'";'.CR_LF;
				$config.='	public static $mailerFromname 		= "'.QLPRequest::getSafe("mailerFromname").'";'.CR_LF;
				$config.='	public static $mailerSuccMessage	= "'.QLPRequest::getSafe("mailerSuccMessage").'";'.CR_LF;
				$config.='	public static $mailerFailedMessage	= "'.QLPRequest::getSafe("mailerFailedMessage").'";'.CR_LF;
				$config.='	public static $mailerSMTPAuth 		= "'.QLPRequest::getInt("mailerSMTPAuth",0).'";'.CR_LF;
				$config.='	public static $mailerSMTPUser 		= "'.QLPRequest::getSafe("mailerSMTPUser").'";'.CR_LF;
				$config.='	public static $mailerSMTPPassword	= "'.QLPRequest::getSafe("mailerSMTPPassword").'";'.CR_LF;
				$config.='	public static $mailerSMTPHost 		= "'.QLPRequest::getSafe("mailerSMTPHost").'";'.CR_LF;
				$config.='	public static $mailerSMTPSecure 	= "'.QLPRequest::getSafe("mailerSMTPSecure","none").'";'.CR_LF;
				$config.='	public static $mailerSMTPPort 		= "'.QLPRequest::getInt("mailerSMTPPort",25).'";'.CR_LF;
				$config.='	public static $defaultLang			= "'.QLPRequest::getSafe("defaultLang").'";'.CR_LF;
				$config.='	public static $debugMode			= "'.QLPRequest::getInt("debugMode").'";'.CR_LF;
				$config.='	public static $experimentalFunctions= "'.QLPRequest::getSafe("experimentalFunctions").'";'.CR_LF;
				$config.='	public static $denyMobileScale		= "'.QLPRequest::getInt("denyMobileScale").'";'.CR_LF;
				$config.='	public static $unlockkey			= "'.QLPRequest::getSafe("unlockkey").'";'.CR_LF;
				$config.='	public static $captchaPublicKey		= "'.QLPRequest::getSafe("captchaPublicKey").'";'.CR_LF;
				$config.='	public static $captchaPrivateKey	= "'.QLPRequest::getSafe("captchaPrivateKey").'";'.CR_LF;
				
				if(isset(QLPConfig::$secret_first) && !$new_password ) $config.='	public static $secret_first			= "1";'.CR_LF;
				$config.='}';
				if(file_put_contents(QLP_CONFIG."config.php", $config)===FALSE) $message.=QLPText::_("Failed to saved");
				else $message.=QLPText::_("Settings saved");
				
				// We need to reset cache !!!
				// if(opcache_get_status() !== FALSE) opcache_reset();
				// @opcache_reset();
				if(function_exists("opcache_reset")) @opcache_reset();
				
				QLPUtil::redirect("/manager.php?module=settings", $message);
			break;	
			default:
				echo '<div class="panel-wrapper module-settings"><div class="row"><div class="col-md-12">';
				echo '<h1 class="panel-title form-title">'.QLPText::_("Settings").'</h1>';
				echo '<form method="post" action="/manager.php">';
				echo '<input type="hidden" value="settings" name="module">';
				echo '<input type="hidden" value="save" name="task">';
				$label_class = 'col-sm-7 lbl';
				$data_class = 'col-sm-5 data';
				$label_class_cb = 'col-xs-10 col-sm-7 lbl';
				$data_class_cb = 'col-xs-2 col-sm-5 data';
				
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site template").'</div><div class="'.$data_class.'"><select name="siteTemplate" class="form-control ">';
				$siteTemplates=QLPFilesystem::getFolders(QLP_ENGINE."tmpl".DS, array("system"));
				if(count($siteTemplates)){
					foreach($siteTemplates as $key=>$template){
						if($key==QLPConfig::$siteTemplate) $selected=' selected="selected"'; else $selected="";
						echo '<option value="'.$key.'"'.$selected.'>'.$key.'</option>';
					}
				}
				echo '</select></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site memory limit").'</div><div class="'.$data_class.'"><input name="siteMemoryLimit" value="'.QLPConfig::$siteMemoryLimit.'" type="text" class="form-control numeric" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site time limit").'</div><div class="'.$data_class.'"><input name="siteTimeLimit" value="'.QLPConfig::$siteTimeLimit.'" type="text" class="form-control numeric" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Flood delay").'</div><div class="'.$data_class.'"><input name="floodDelay" value="'.(isset(QLPConfig::$floodDelay) ? QLPConfig::$floodDelay : 5).'" type="text" class="form-control numeric" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class_cb.'">'.QLPText::_("Move CSS to footer").'</div><div class="'.$data_class_cb.'"><input id="siteCSS2footer" name="siteCSS2footer" value="1" '.(QLPConfig::$siteCSS2footer ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class_cb.'">'.QLPText::_("Include, if possible, CSS into body").'</div><div class="'.$data_class_cb.'"><input id="siteIncludeCSS2body" name="siteIncludeCSS2body" value="1" '.(QLPConfig::$siteIncludeCSS2body ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class_cb.'">'.QLPText::_("Include, if possible, Javascript into body").'</div><div class="'.$data_class_cb.'"><input id="siteIncludeJS2body" name="siteIncludeJS2body" value="1" '.(QLPConfig::$siteIncludeJS2body ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Admin login").'</div><div class="'.$data_class.'"><input name="adminLogin" value="'.QLPConfig::$adminLogin.'" type="text" class="form-control" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Password").(isset(QLPConfig::$secret_first) ? '<span class="fatal">'.QLPText::_("Password is open. Please, change it.").'</span>' : '').'</div><div class="'.$data_class.'"><input name="secret1" value="" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Password confirmation").'</div><div class="'.$data_class.'"><input name="secret2" value="" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Admin template").'</div><div class="'.$data_class.'"><select name="adminTemplate" class="form-control">';
				$adminTemplates=QLPFilesystem::getFolders(QLP_MANAGE."tmpl".DS);
				if(count($adminTemplates)){
					foreach($adminTemplates as $key=>$template){
						if($key==QLPConfig::$adminTemplate) $selected=' selected="selected"'; else $selected="";
						echo '<option value="'.$key.'"'.$selected.'>'.$key.'</option>';
					}
				}
				echo '</select></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Admin memory limit").'</div><div class="'.$data_class.'"><input name="adminMemoryLimit" value="'.QLPConfig::$adminMemoryLimit.'" type="text" class="form-control numeric" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Admin time limit").'</div><div class="'.$data_class.'"><input name="adminTimeLimit" value="'.QLPConfig::$adminTimeLimit.'" type="text" class="form-control numeric" required /></div></div>';
//				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site cache").'</div><div class="'.$data_class.'"><input id="siteCache" name="siteCache" value="1" '.(QLPConfig::$siteCache ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
//				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site cache time, s").'</div><div class="'.$data_class.'"><input name="siteCachetime" value="'.QLPConfig::$siteCachetime.'" type="text" class="form-control numeric" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site meta title").'</div><div class="'.$data_class.'"><input name="siteMetaTitle" value="'.QLPConfig::$siteMetaTitle.'" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site meta keywords").'</div><div class="'.$data_class.'"><input name="siteMetaKeys" value="'.QLPConfig::$siteMetaKeys.'" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Site meta description").'</div><div class="'.$data_class.'"><textarea name="siteMetaDesc" class="form-control">'.QLPConfig::$siteMetaDesc.'</textarea></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Mailer from Email").'</div><div class="'.$data_class.'"><input name="mailerFrom" value="'.QLPConfig::$mailerFrom.'" type="text" class="form-control" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Mailer from name").'</div><div class="'.$data_class.'"><input name="mailerFromname" value="'.QLPConfig::$mailerFromname.'" type="text" class="form-control" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Mailer successfull message").'</div><div class="'.$data_class.'"><input name="mailerSuccMessage" value="'.QLPConfig::$mailerSuccMessage.'" type="text" class="form-control" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Mailer failed message").'</div><div class="'.$data_class.'"><input name="mailerFailedMessage" value="'.QLPConfig::$mailerFailedMessage.'" type="text" class="form-control" required /></div></div>';
//				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Mailer SMTP authorization").'</div><div class="'.$data_class.'"><input id="mailerSMTPAuth" name="mailerSMTPAuth" value="1" '.(QLPConfig::$mailerSMTPAuth ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("SMTP user").'</div><div class="'.$data_class.'"><input name="mailerSMTPUser" value="'.QLPConfig::$mailerSMTPUser.'" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("SMTP password").'</div><div class="'.$data_class.'"><input name="mailerSMTPPassword" value="'.QLPConfig::$mailerSMTPPassword.'" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("SMTP host").'</div><div class="'.$data_class.'"><input name="mailerSMTPHost" value="'.QLPConfig::$mailerSMTPHost.'" type="text" class="form-control" required /></div></div>';
//				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("SMTP secure").'</div><div class="'.$data_class.'"><input name="mailerSMTPSecure" value="'.QLPConfig::$mailerSMTPSecure.'" type="text" class="form-control" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("SMTP port").'</div><div class="'.$data_class.'"><input name="mailerSMTPPort" value="'.QLPConfig::$mailerSMTPPort.'" type="text" class="form-control" required /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class_cb.'">'.QLPText::_("Experimental functions").'<span class="fatal">'.QLPText::_("Use with caution, enable only on your own risk").'</span></div><div class="'.$data_class_cb.'"><input id="experimentalFunctions" name="experimentalFunctions" value="1" '.((isset(QLPConfig::$experimentalFunctions) && QLPConfig::$experimentalFunctions) ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
				//echo '<div class="row row-form"><div class="'.$label_class_cb.'">'.QLPText::_("Debug mode").'</div><div class="'.$data_class_cb.'"><input id="debugMode" name="debugMode" value="1" '.(QLPConfig::$debugMode ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class_cb.'">'.QLPText::_("Debug mode").'</div><div class="'.$data_class_cb.'"><select name="debugMode" class="form-control">';
				echo '<option value="0"'.(QLPConfig::$debugMode=='0' ? ' selected="selected"': '').'>'.QLPText::_("Disabled").'</option>';
				echo '<option value="1"'.(QLPConfig::$debugMode=='1' ? ' selected="selected"': '').'>'.QLPText::_("Visible to admin").'</option>';
				echo '<option value="2"'.(QLPConfig::$debugMode=='2' ? ' selected="selected"': '').'>'.QLPText::_("Visible to all").'</option>';
				echo '</select></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Language").'</div><div class="'.$data_class.'"><select name="defaultLang" class="form-control">';
				echo '<option value="ru-RU"'.(QLPConfig::$defaultLang=='ru-RU' ? ' selected="selected"': '').'>ru-RU</option>';;
				echo '<option value="en-US"'.(QLPConfig::$defaultLang=='en-US' ? ' selected="selected"': '').'>en-US</option>';;
				echo '</select></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class_cb.'">'.QLPText::_("Deny mobile scale").'</div><div class="'.$data_class_cb.'"><input id="denyMobileScale" name="denyMobileScale" value="1" '.(QLPConfig::$denyMobileScale ? ' checked="checked"' : '').' type="checkbox" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Captcha Public Key").'</div><div class="'.$data_class.'"><input name="captchaPublicKey" value="'.QLPConfig::$captchaPublicKey.'" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Captcha Private Key").'</div><div class="'.$data_class.'"><input name="captchaPrivateKey" value="'.QLPConfig::$captchaPrivateKey.'" type="text" class="form-control" /></div></div>';
				echo '<div class="row row-form"><div class="'.$label_class.'">'.QLPText::_("Unlock key").'</div><div class="'.$data_class.'"><input name="unlockkey" value="'.QLPConfig::$unlockkey.'" type="text" class="form-control" /></div></div>';
				echo '<div class="buttons"><input class="button" type="submit" value="'.QLPText::_("Save").'" /><a class="button" href="'.(QLPRequest::getSafe("return")=="front" ? "/": "/manager.php").'">'.QLPText::_("Close").'</a></div>';
				echo '</form>';
				echo '</div></div></div>';
			break;
		}
		return true;
	}
}