<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: 5ce7866 (2019-08-18 16:52:45)
//

defined('_QUICK_LP') or die("Access denied");

class kcaptchaQLPPlugin extends QLPPlugin {
	protected $_events=array("captcha.renderPicture","captcha.renderForm","captcha.checkResult");	
	public function prepare(){
		$this->registerEvents();
	}
	protected function onRaise($event, &$data) {
		switch($event){
			case "captcha.renderPicture":
				include_once QLP_SITE."redistribution".DS."php".DS."kcaptcha".DS."kcaptcha.php";
				$captcha = new KCAPTCHA();
				if(QLPRequest::get(session_name())) {
					$captchaValid = QLPSession::getInstance()->getVar("captcha_string");
					if(!is_array($captchaValid)) $captchaValid=array();
					$captchaValid[]=$captcha->getKeyString();
					QLPSession::setVar("captcha_string", $captchaValid);
				}
			break;
			case "captcha.renderForm":
				$html = "<label for=\"feedback_message\">".QLPText::_("Captcha")."</label>";
				$html .= "<div class=\"captcha\">";
				$html .= "<table class=\"captcha\"><tr><td rowspan=\"2\" class=\"captcha\">";
				$html.= "	<img src=\"/index.php?task=captcha&amp;".session_name()."=".session_id()."\" alt=\"\" />";
				$html.= "</td>";
				$html.= "<tr><td class=\"captchainput\">";
				$html.= "	<input id=\"rCaptchaText\" class=\"required\" name=\"rCaptchaText\" type=\"text\" />";
				$html.= "</td></tr></table>";
				$html.= "</div>";
				return $html;
				break;
			case "captcha.checkResult":
				$sess = QLPSession::getInstance();
				$captcha	= QLPRequest::get('rCaptchaText','');
				$captchaValid = QLPSession::getInstance()->getVar("captcha_string");
				QLPSession::getInstance()->unsetVar("captcha_string");
				if ( is_array($captchaValid) && in_array($captcha, $captchaValid)) {
					return true;
				} else {
					return false;
				}
			break;
		}
		
	}
}
?>