<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: e2a7edf (2019-03-22 14:38:52)
//

defined('_QUICK_LP') or die("Access denied");

class recaptchaQLPPlugin extends QLPPlugin {
	protected $_events=array("captcha.renderForm","captcha.checkResult");	
	public function prepare(){
		$js="
			var reCaptchaRequested=false;
			function captureEveryLoad(parent_prefix){
				if( typeof( parent_prefix ) != 'undefined' && parent_prefix) parent_prefix=parent_prefix+' ';  else parent_prefix=''; 
				$(parent_prefix + '.recaptcha').each(function(){
					var old_id = $(this).attr('recaptcha-id');
					if(old_id){
						$(this).html('');
					}
					id=grecaptcha.render($(this).get(0), {'sitekey' : $(this).attr('data-sitekey')});
					$(this).attr('recaptcha-id', id);
				})
			}
			function requestReCapture(){
				$.getScript('https://www.google.com/recaptcha/api.js?onload=captureEveryLoad&render=explicit', function() {});
			}
			$(window).load(function() {
				if ( reCaptchaRequested==false && typeof( grecaptcha ) === 'undefined') {
					reCaptchaRequested = setTimeout(function() {
						requestReCapture();
					}, 3000);
				}
			});
			";
		QLPTemplate::getInstance()->addScriptDeclaration($js);
		$this->registerEvents();
	}
	protected function onRaise($event, &$data) {
		switch($event){
			case "captcha.renderForm":
				$html = "<div class=\"captcha\">";
				if(QLPConfig::$captchaPublicKey){
					$html.= "<div class=\"recaptcha\" data-sitekey=\"".QLPConfig::$captchaPublicKey."\"></div>";
				} else {
					$html.= QLPText::_("Wrong captcha key");
				}
				$html.= "</div>";
				return $html;
				break;
			case "captcha.checkResult":
				if(QLPConfig::$captchaPrivateKey) {
					$ch = curl_init();
					$RemoteURL = "https://www.google.com/recaptcha/api/siteverify";
					$RequestTimeout = 4;
					$RemoteQuery["secret"]=QLPConfig::$captchaPrivateKey;
					$RemoteQuery["response"]=QLPRequest::getSafe("g-recaptcha-response");
					$RemoteQuery["remoteip"]=QLPSession::getInstance()->getIP();
					curl_setopt($ch, CURLOPT_URL, $RemoteURL); // set url to post to
					curl_setopt($ch, CURLOPT_FAILONERROR, 1);
					curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER,1); // return into a variable
					curl_setopt($ch, CURLOPT_TIMEOUT, $RequestTimeout); // times out after 4s
					curl_setopt($ch, CURLOPT_POST, 1); // set POST method
					curl_setopt($ch, CURLOPT_POSTFIELDS, $RemoteQuery); // add POST fields
					$result = curl_exec($ch); // run the whole process
					curl_close($ch);
					$resp=json_decode($result, true);
					if (is_array($resp) && $resp["success"] == true) {
						return true;
					} else { 
						return false;
					}
				} else {
					return false;
				}
				break;
			default: 
				return false;
				break;
		}
	
	}
}
?>