<?php
// Quick-LP
// Copyright (c) Radius17
// Web: https://quick-lp.ru
// Commercial license https://quick-lp.ru/license.txt
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// Revision: fea72c2 (2020-07-20 15:58:52)
//

defined('_QUICK_LP') or die("Access denied");

class chartQLPWidget extends QLPWidget{
	public function prepare(){
		QLPTemplate::getInstance()->addScript("/redistribution/js/jquery.plugins/jquery.waypoints".(QLP_MINIFIED_ASSETS ? ".min" : "").".js");
		QLPTemplate::getInstance()->addScript("//cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.3/jquery.easing.min.js", true);
		QLPTemplate::getInstance()->addScript("/redistribution/js/jquery.easypiechart/jquery.easypiechart".(QLP_MINIFIED_ASSETS ? ".min" : "").".js");
		QLPTemplate::getInstance()->addStyleSheet("/redistribution/js/jquery.easypiechart/jquery.easypiechart".(QLP_MINIFIED_ASSETS ? ".min" : "").".css", true);
	}
	public function render($_render_count, $params){
		if(array_key_exists("percent", $params) && $params["percent"]) $percent=$params["percent"]; else $percent="100";
		if(array_key_exists("duration", $params) && intval($params["duration"])) $duration=intval($params["duration"]); else $duration="1000";
		if(array_key_exists("title", $params) && $params["title"]) $title=$params["title"]; else $title="";
		if(array_key_exists("lineWidth", $params) && intval($params["lineWidth"])) $lineWidth=intval($params["lineWidth"]); else $lineWidth="10";

		$content = "<div id=\"chart_".$_render_count."\" class=\"chart-wrapper\"><p style=\"text-align: center;\"><span class=\"chart\" data-percent=\"".$percent."\"><span class=\"percent\"></span></span></p>";
		if($title) $content.= "<h4 style=\"text-align: center;\">".$title."</h4>";
		$content.="</div>";
		
		$script="$(window).load(function(){
			$('#chart_".$_render_count." .chart').waypoint(function() {
				$('#chart_".$_render_count." .chart').easyPieChart({
					lineWidth:".$lineWidth.",
					scaleLength:0,
					easing: 'easeOutBounce',
					animate: {
						duration: ".$duration.",
						enabled: true
					},
					onStep: function(from, to, percent) {
						$(this.el).find('.percent').text(Math.round(percent));
					}
				});
			}, {
				triggerOnce: true,
				offset: 'bottom-in-view'
			});
		});
		";
		
		QLPTemplate::getInstance()->addScriptDeclaration($script);
		
		return $content; 
	}
}